package de.davidochmann.framework.dosite.content 
{	
	/**
	 * @author dochmann
	 */
	
	public class XmlManagerComposition
	{
		private static var mInstance:XmlManagerComposition;
		private var mXmlReceiver:XmlReceiver;


		public function XmlManagerComposition(pSingeltonEnforcer:SingeltonEnforcer){}
		
		public static function getInstance():XmlManagerComposition
		{
			if(! mInstance)
				mInstance = new XmlManagerComposition(new SingeltonEnforcer());
			
			return mInstance;
		}


		public function initialize():void
		{
			initXmlReceiver();
		}

		public function getReceiver():XmlReceiver
		{
			return mXmlReceiver;
		}

		
		public function getFormationLength():uint
		{
			var length:uint = mXmlReceiver.getXml().COMPOSITION.FORMATION.children().length();
			return length; 
		}
		
		public function getSetup():Object
		{
			var setup:Object = new Object();
			var list:XMLList = new XMLList(mXmlReceiver.getXml().COMPOSITION.SETUP);
			
			var type:String		= String(list.TYPE.attribute("type"));
			var init:String   	= String(list.SITE.attribute("init"));
			var position:String = String(list.SITE.attribute("position"));
			
			setup = {type:type, init:init, position:position};
			
			return setup;
		}
				
		public function getFormation(pIndex:uint):Object
		{
			var formation:Object = new Object();
			var list:XMLList     = new XMLList(mXmlReceiver.getXml().COMPOSITION.FORMATION.ITEM[pIndex]);
			
			var id:String 	 = String(list.attribute("id"));
			var type:String  = String(list.attribute("type"));
			var title:String = String(list.attribute("title"));
			var x:int 		 = int   (list.attribute("x"));
			var y:int 		 = int   (list.attribute("y"));
			var width:uint   = uint  (list.attribute("width"));
			var height:uint  = uint  (list.attribute("height"));
			
			formation = {id:id, type:type, title:title, x:x, y:y, width:width, height:height};
			
			return formation;
		}

		
		private function initXmlReceiver():void
		{
			mXmlReceiver = new XmlReceiver();
		}
	}
}

class SingeltonEnforcer{}
