﻿package de.davidochmann.framework.dosite.content
{
	/**
	 * @author David Ochmann
	 */
	
	public class XmlManagerContent
	{
		private static var mInstance:XmlManagerContent;
		private var mXmlReceiver:XmlReceiver;


		public function XmlManagerContent(pSingeltonEnforcer:SingeltonEnforcer){}
		
		public static function getInstance():XmlManagerContent
		{
			if(! mInstance)
				mInstance = new XmlManagerContent(new SingeltonEnforcer());
			
			return mInstance;
		}


		public function initialize():void
		{
			initXmlReceiver();
		}

		public function getReceiver():XmlReceiver
		{
			return mXmlReceiver;
		}
		
				
		public function getGraphicLength():uint
		{
			var length:uint = mXmlReceiver.getXml().CONTENT.GRAPHIC.children().length();
			return length; 
		}

		public function getExtensibleLength():uint
		{
			var length:uint = mXmlReceiver.getXml().CONTENT.EXTENSIBLE.children().length();
			return length;
		}

		
		public function getSetup():Object
		{
			var setup:Object = new Object();
			var list:XMLList = new XMLList(mXmlReceiver.getXml().CONTENT.SETUP);
			
			var type:String = String(list.TYPE.attribute("type"));
			
			setup = {type:type};
						
			return setup;	
		}

		public function getExtensible(pIndex:uint):Object
		{
			var extensible:Object = new Object();
			var list:XMLList = new XMLList(mXmlReceiver.getXml().CONTENT.EXTENSIBLE.ITEM[pIndex]);
						
			var id:String   = String(list.attribute("id"));
			var path:String = String(list.attribute("path"));
			
			extensible = {id:id, path:path};
			
			return extensible;
		}

		public function getGraphic(pIndex:uint):Object
		{
			var graphic:Object = new Object();
			var list:XMLList = new XMLList(mXmlReceiver.getXml().CONTENT.GRAPHIC.ITEM[pIndex]);
			
			var id:String   = String(list.attribute("id"));
			var path:String = String(list.attribute("path"));

			graphic = {id:id, path:path};
			
			return graphic;
		}
		
		
		private function initXmlReceiver():void
		{
			mXmlReceiver = new XmlReceiver();
		}
	}
}

class SingeltonEnforcer{}
