package de.davidochmann.framework.dosite.content 
{
	/**
	 * @author dochmann
	 */

	public class XmlManagerDoSite
	{
		private static var mInstance:XmlManagerDoSite;
		private var mXmlReceiver:XmlReceiver;


		public function XmlManagerDoSite(pSingeltonEnforcer:SingeltonEnforcer){}
		
		public static function getInstance():XmlManagerDoSite
		{
			if(! mInstance)
				mInstance = new XmlManagerDoSite(new SingeltonEnforcer());
				
			return mInstance;
		}
		
		public function initialize():void
		{
			initXmlReceiver();		
		}
		
		
		public function getReceiver():XmlReceiver
		{
			return mXmlReceiver;
		}


		public function getSetup():Object
		{			
			var setup:Object = new Object();
			var list:XMLList = new XMLList(mXmlReceiver.getXml().DOSITE.SETUP);
			
			var type:String		   = String(list.TYPE.attribute("type"));
			var content:String     = String(list.CONTENT.attribute("path"));
			var composition:String = String(list.COMPOSITION.attribute("path"));
			
			setup = {type:type, composition:composition, content:content};
			
			return setup;
		}

		
		private function initXmlReceiver():void
		{
			mXmlReceiver = new XmlReceiver();
		}
	}
}

class SingeltonEnforcer{}