package de.davidochmann.framework.dosite.data
{
	/**
	 * @author dochmann
	 */
	
	import flash.display.Stage;	
	import de.davidochmann.framework.dosite.list.SetupList;	
	import de.davidochmann.framework.dosite.list.ExtensibleList;	
	import de.davidochmann.framework.dosite.list.GraphicList;	
	import de.davidochmann.framework.dosite.list.CompositionList;	

	public class DataManager 
	{
		private static var mInstance:DataManager;
		
		private var mStage:Stage;

		private var mSetupList:SetupList;
		private var mExtensibleList:ExtensibleList;
		private var mGraphicList:GraphicList;
		private var mCompositionList:CompositionList;

	
		public function DataManager(pSingeltonEnforcer:SingeltonEnforcer){}
		
		public static function getInstance():DataManager
		{
			if(! mInstance)
				mInstance = new DataManager(new SingeltonEnforcer());
				
			return mInstance;
		}
		
		
		public function initialize(pStage:Stage):void
		{
			setStage(pStage);	
			
			initSetupList();
			initExtensibleList();
			initGraphicList();
			initCompositionList();
		}


		public function setup():SetupList
		{
			return mSetupList;
		}	

		public function extensible():ExtensibleList
		{
			return mExtensibleList;
		}

		public function graphic():GraphicList
		{
			return mGraphicList;
		}

		public function composition():CompositionList
		{
			return mCompositionList;
		}


		public function getStage():Stage
		{
			return mStage;
		}

		public function setStage(pStage:Stage):void
		{
			mStage = pStage;
		}

		
		private function initSetupList():void
		{
			mSetupList = SetupList.getInstance();
		}

		private function initExtensibleList():void
		{
			mExtensibleList = ExtensibleList.getInstance();
		}

		private function initGraphicList():void
		{
			mGraphicList = GraphicList.getInstance();
		}

		private function initCompositionList():void
		{
			mCompositionList = CompositionList.getInstance();
		}
	}
}

class SingeltonEnforcer{}