package de.davidochmann.framework.dosite.data.register 
{
	/**
	 * @author MR.WUT4
	 */
	 
	public class DisplayRegister 
	{
		private static var mInstance:DisplayRegister;
		
		private var mImageRegister:ImageRegister;
		private var mContentRegister:ContentRegister;
		private var mSubsiteRegister:SubsiteRegister;
		
		
		public function DisplayRegister(pSingeltonEnforcer:SingeltonEnforcer);
		
		public static function getInstance():DisplayRegister
		{
			if(! mInstance)
				mInstance = new DisplayRegister(new SingeltonEnforcer());
				
			return mInstance;
		}		
		
		
		public function initialize():void
		{
			initImageRegister();
			initContentRegister();
			initSubsiteRegister();	
		}
	
	
		public function image():ImageRegister
		{
			return mImageRegister;
		}
		
		public function content():ContentRegister
		{
			return mContentRegister;
		}	
		
		public function subsite():SubsiteRegister
		{
			return mSubsiteRegister;
		}

		
		private function initImageRegister():void
		{
			mImageRegister = ImageRegister.getInstance();
			mImageRegister.initialize();
		}
		
		private function initContentRegister():void
		{
			mContentRegister = ContentRegister.getInstance();
			mContentRegister.initialize();
		}
		
		private function initSubsiteRegister():void
		{
			mSubsiteRegister = SubsiteRegister.getInstance();
			mSubsiteRegister.initialize();
		}
	}
}

class SingeltonEnforcer{}