package de.davidochmann.framework.dosite.data.register
{
	/**
	 * @author MR.WUT4
	 */
	
	import flash.events.EventDispatcher;		
	import de.davidochmann.framework.dosite.graphic.container.ImageContainer;	
	import de.davidochmann.framework.dosite.graphic.container.ContentContainer;	
	import de.davidochmann.framework.dosite.event.ImageContainerEvent;	
	import de.davidochmann.framework.dosite.event.ContentContainerEvent;	
	import de.davidochmann.framework.dosite.event.LoadingRegisterEvent;	
	import de.davidochmann.framework.dosite.event.SubsiteContainerEvent;	
	import de.davidochmann.framework.dosite.graphic.container.SubsiteContainer;	
	
	public class LoadingRegister extends EventDispatcher
	{
		private static var mInstace:LoadingRegister;
		
		private var mCompleteSubsiteCounter:uint;
		private var mCompleteContentCounter:uint;
		private var mCompleteImageCounter:uint;
		private var mCompleteAllCounter:uint;

		private var mSubsiteContainerList:Array;
		private var mContentContainerList:Array;
		private var mImageContainerList:Array;			
		
		
		public function LoadingRegister(pSingeltonEnforcer:SingeltonEnforcer){}
		
		public static function getInstance():LoadingRegister
		{
			if(! mInstace)
				mInstace = new LoadingRegister(new SingeltonEnforcer());
				
			return mInstace;		
		}
		
		
		public function initialize():void
		{
			initCompleteSubsiteCounter();
			initCompleteContentCounter();
			initCompleteImageCounter();
			initCompleteAllCounter();
			
			initSubsiteContainerList();
			initContentContainerList();
			initImageContainerList();			
		}
				
		public function subsiteComplete(e:SubsiteContainerEvent):void
		{
			mCompleteSubsiteCounter ++;
			
			if(mCompleteSubsiteCounter == mSubsiteContainerList.length)
				dispatchEvent(new LoadingRegisterEvent(LoadingRegisterEvent.SUBSITE_COMPLETE));
				
			downloadComplete();
		}

		public function contentComplete(e:ContentContainerEvent):void
		{
			mCompleteContentCounter ++;
			
			if(mCompleteContentCounter == mContentContainerList.length)
				dispatchEvent(new LoadingRegisterEvent(LoadingRegisterEvent.CONTENT_COMPLETE));
			
			downloadComplete();			
		}

		public function imageComplete(e:ImageContainerEvent):void
		{
			mCompleteImageCounter ++;
			
			if(mCompleteImageCounter == mImageContainerList.length)
				dispatchEvent(new LoadingRegisterEvent(LoadingRegisterEvent.GRAPHIC_COMPLETE));
				
			downloadComplete();
		}

		private function downloadComplete():void
		{
			var containerLength:uint = mSubsiteContainerList.length + mContentContainerList.length + mImageContainerList.length;
			
			mCompleteAllCounter = mCompleteSubsiteCounter + mCompleteContentCounter + mCompleteImageCounter;
			
			if(containerLength == mCompleteAllCounter)
				dispatchEvent(new LoadingRegisterEvent(LoadingRegisterEvent.ALL_COMPLETE));
		}

		
		public function addSubsiteContainer(pSubsiteContainer:SubsiteContainer):void
		{
			mSubsiteContainerList.push(pSubsiteContainer);	
		}

		public function addContentContainer(pContentContainer:ContentContainer):void
		{
			mContentContainerList.push(pContentContainer);	
		}

		public function addImageContainer(pImageContainer:ImageContainer):void
		{
			mImageContainerList.push(pImageContainer);
		}

		
		private function initCompleteSubsiteCounter():void
		{
			mCompleteSubsiteCounter = 0;			
		}

		private function initCompleteContentCounter():void
		{
			mCompleteContentCounter = 0;
		}

		private function initCompleteImageCounter():void
		{
			mCompleteImageCounter = 0;
		}

		private function initCompleteAllCounter():void
		{
			mCompleteAllCounter = 0;
		}


		private function initSubsiteContainerList():void
		{
			mSubsiteContainerList = new Array();	
		}
		
		private function initContentContainerList():void
		{
			mContentContainerList = new Array();
		}
		
		private function initImageContainerList():void
		{
			mImageContainerList = new Array();
		}		
	}
}

class SingeltonEnforcer{}