package de.davidochmann.framework.dosite.data.register 
{	
	/**
	 * @author MR.WUT4
	 */

	import de.davidochmann.framework.dosite.interfaces.ISubsite;	

	public class SubsiteRegister 
	{
		private static var mInstance:SubsiteRegister;
		private var mList:Array;
			
			
		public function SubsiteRegister(pSingeltonEnforcer:SingeltonEnforcer){}
		
		public static function getInstance():SubsiteRegister
		{
			if(! mInstance)
				mInstance = new SubsiteRegister(new SingeltonEnforcer());
				
			return mInstance;
		}


		public function initialize():void
		{
			initList();	
		}

			
		public function list():Array
		{
			return mList;
		}

		public function add(pSubsite:ISubsite, pId:String):void
		{
			var object:Object = new Object();
			object = {id:pId, obj:pSubsite};
			mList.push(object);			
		}

		public function item(pId:String):ISubsite
		{
			var object:Object;
			var subsite:ISubsite;
			
			for(var i:uint = 0; i < mList.length; ++i)
			{
				object = mList[i];
				
				if(object.id == pId)
				{
					subsite = object.obj;
					break;	
				} 		
			}
			
			return subsite;
		}
		
		public function items(pId:String):Array
		{
			var object:Object;
			var list:Array = new Array();
			
			for(var i:uint = 0; i < mList.length; ++i)
			{
				object = mList[i];
				
				if(object.id == pId)
					list.push(object.obj);
			}
			
			return list;
		}
		
		
		private function initList():void
		{
			mList = new Array();
		}
	}
}

class SingeltonEnforcer{}