package de.davidochmann.framework.dosite.framework 
{
	/**
	 * @author dochmann
	 */
	
	import flash.events.Event;	
	import de.davidochmann.framework.dosite.event.LoadingRegisterEvent;		
	import de.davidochmann.framework.dosite.event.XmlReaderEvent;	

	public class FrameworkEventHandler 
	{
		private static var mInstance:FrameworkEventHandler;
		
		private var mFramework:Framework;

		
		public function FrameworkEventHandler(pSingeltonEnforcer:SingeltonEnforcer){}
		
		public static function getInstance():FrameworkEventHandler
		{
			if(! mInstance)
				mInstance = new FrameworkEventHandler(new SingeltonEnforcer());
				
			return mInstance;
		}
		
		public function initialize():void
		{
			initFramework();
			initEventHandler();
		}
		
		
		private function initEventHandler():void
		{	
			mFramework.xmlReader().addEventListener(XmlReaderEvent.DOSITE_COMPLETE, xmlReaderDoSiteCompleteHandler);
			mFramework.xmlReader().addEventListener(XmlReaderEvent.ALL_COMPLETE, xmlReaderAllCompleteHandler);
			mFramework.loadingRegister().addEventListener(LoadingRegisterEvent.SUBSITE_COMPLETE, loadingSubsiteCompleteHandler);
			mFramework.getStage().addEventListener(Event.RESIZE, stageResizeEventHandler);
		}

		
		private function xmlReaderDoSiteCompleteHandler(e:XmlReaderEvent):void
		{
			mFramework.xmlReader().loadContentXml();
			mFramework.xmlReader().loadCompositionXml();
		}

		private function xmlReaderAllCompleteHandler(e:XmlReaderEvent):void
		{
			mFramework.buildSetupList();
			mFramework.buildExtensibleList();
			mFramework.buildGraphicList();
			mFramework.buildCompositionList();
			
			mFramework.buildDisplayElements();
			mFramework.initContainerPosition();
			mFramework.initDisplayElements();
		}		

		private function loadingSubsiteCompleteHandler(e:LoadingRegisterEvent):void
		{
			mFramework.allowNavigation();			
		}

		private function stageResizeEventHandler(e:Event):void
		{
			mFramework.initContainerPosition();
		}

		
		private function initFramework():void
		{
			mFramework = Framework.getInstance();
		}
	}
}

class SingeltonEnforcer{}