package de.davidochmann.framework.dosite.graphic.base 
{
	/**
	 * @author MR.WUT4
	 */
	 
	import flash.net.URLRequest;	
	import flash.display.Loader;	
	import flash.display.DisplayObject;	
	import flash.system.ApplicationDomain;	
	import flash.system.LoaderContext;	

	public class GraphicLoader 
	{
		private var mName:String;
		private var mPath:String;
		private var mLoad:Boolean;

		private var mLoader:Loader;
	
		public function GraphicLoader(pName:String,
									  pPath:String,
									  pLoad:Boolean = true)
		{
			setName(pName);
			setPath(pPath);
			setLoad(pLoad);

			initLoader();

			if(mLoad)				
				load();
		}
		
		
		public function load():void
		{			
			mLoader.load(new URLRequest(mPath), new LoaderContext(false, ApplicationDomain.currentDomain));
		}

		public function unload():void
		{
			mLoader.unload();
		}
				
		public function content():DisplayObject
		{
			return mLoader.content;
		}
		
		public function loader():Loader
		{
			return mLoader;
		}


		public function getName():String
		{
			return mName;
		}
		
		public function getPath():String
		{
			return mPath;
		}
		
		public function getLoad():Boolean
		{
			return mLoad;
		}

		
		public function setName(pName:String):void
		{
			mName = pName;
		}

		public function setPath(pPath:String):void
		{
			mPath = pPath;
		}

		public function setLoad(pLoad:Boolean):void
		{
			mLoad = pLoad;
		}

		
		private function initLoader():void
		{
			mLoader = new Loader();	
		}
	}
}
