package de.davidochmann.framework.dosite.graphic.container 
{
	/**
	 * @author MR.WUT4
	 */
	
	import flash.events.Event;	
	import flash.events.EventDispatcher;	
	import de.davidochmann.framework.dosite.event.ContentContainerEvent;	
	import de.davidochmann.framework.dosite.graphic.base.GraphicLoader;

	public class ContentContainer extends EventDispatcher
	{
		private var mFormat:Object;
		private var mGraphic:Object;
		private var mExtensible:Object;
		private var mDepth:uint;
		private var mLoad:Boolean;
		
		private var mGraphicLoader:GraphicLoader;
	
	
		public function ContentContainer(pFormat:Object,
									   	 pGraphic:Object,
									   	 pExtensible:Object,
									   	 pDepth:uint = undefined,
									   	 pLoad:Boolean = false)
		{
			setFormat(pFormat);
			setGraphic(pGraphic);
			setExtensible(pExtensible);
			setDepth(pDepth);
			setLoad(pLoad);
			
			initGraphicLoader();	
		}
		
		
		public function graphicLoader():GraphicLoader
		{
			return mGraphicLoader;
		}

		
		public function getFormat():Object
		{
			return mFormat;
		}
		
		public function getGraphic():Object
		{
			return mGraphic;
		}

		public function getExtensible():Object
		{
			return mExtensible;
		}

		public function getDepth():uint
		{
			return mDepth;
		}

		public function getLoad():Boolean
		{
			return mLoad;
		}

		
		public function setFormat(pFormat:Object):void
		{
			mFormat = pFormat;
		}
		
		public function setGraphic(pGraphic:Object):void
		{
			mGraphic = pGraphic;
		}

		public function setExtensible(pExtensible:Object):void
		{
			mExtensible = pExtensible;
		}

		public function setDepth(pDepth:uint):void
		{
			mDepth = pDepth;
		}

		public function setLoad(pLoad:Boolean):void
		{
			mLoad = pLoad;
		}

		
		private function initGraphicLoader():void
		{
			var name:String  = mFormat.name; 
			var path:String  = mGraphic.path;
			var load:Boolean = mLoad;
						
			mGraphicLoader = new GraphicLoader(name, path, load);		
			mGraphicLoader.loader().contentLoaderInfo.addEventListener(Event.COMPLETE, loaderCompleteHandler);		
		}	
		
		private function loaderCompleteHandler(e:Event):void
		{
			dispatchEvent(new ContentContainerEvent(ContentContainerEvent.LOAD_COMPLETE, mDepth));	
		}
	}
}
