package de.davidochmann.framework.dosite.graphic.container 
{	
	/**
	 * @author MR.WUT4
	 */
	
	import flash.display.Stage;	
	import flash.display.Sprite;	
	import de.davidochmann.framework.dosite.data.DataManager;	
	import de.davidochmann.framework.dosite.graphic.window.Window;	
	import de.davidochmann.framework.dosite.graphic.support.Position;	

	public class DisplayContainer 
	{
		private static var mInstance:DisplayContainer;
		
		private var mDataManager:DataManager;
		private var mContainer:Sprite;
		
		private var mGraphicContainer:Sprite;
		private var mContentContainer:Sprite; 
		private var mSubsiteWindow:Window;	

		public function DisplayContainer(pSingeltonEnforcer:SingeltonEnforcer){}	
		
		public static function getInstance():DisplayContainer
		{
			if(! mInstance)
				mInstance = new DisplayContainer(new SingeltonEnforcer());
				
			return mInstance;
		}
		
		
		public function initialize():void
		{
			initDataManager();
			
			initGraphicContainer();
			initContentContainer();
			initSubsiteWindow();
			
			initContainer();
		}
		
		
		public function container():Sprite
		{
			return mContainer;
		}

		public function graphic():Sprite
		{
			return mGraphicContainer;
		}

		public function content():Sprite
		{
			return mContentContainer;
		}
		
		public function subsite():Window
		{
			return mSubsiteWindow;
		}

	
		public function initContainerPosition():void
		{
			if(mDataManager.setup().search("type", "composition").length != 0)
			{
				var siteStage:Stage 	 = mDataManager.getStage();
				var siteContainer:Sprite = mContainer;
				var sitePosition:String	 = mDataManager.setup().search("type", "composition")[0].position;
				
				Position.stage(siteStage, siteContainer, sitePosition);
			}		
		}

				
		private function initDataManager():void
		{
			mDataManager = DataManager.getInstance();
		}

		
		private function initGraphicContainer():void
		{
			mGraphicContainer = new Sprite();
		}

		private function initContentContainer():void
		{
			mContentContainer = new Sprite();
		}

		private function initSubsiteWindow():void
		{
			mSubsiteWindow = new Window();
		}

		private function initContainer():void
		{
			mContainer = new Sprite();
			mContainer.mouseEnabled = true;
			mContainer.mouseChildren = true;
			
			mContainer.addChild(mContentContainer);
			mContainer.addChild(mGraphicContainer);
			mContainer.addChild(mSubsiteWindow);		
		}
	}
}

class SingeltonEnforcer{}